package jeremiahteague.com;

import java.util.Arrays;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.ToggleButton;
import android.os.CountDownTimer;
import android.app.AlertDialog;
//import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;



public class Hello extends Activity implements Constants{
    
    private Button btnNewGame;
    
    //private Button btn;
    public static final String PREFS_NAME = "MyPrefsFile";
    public static TextView txtTimer;
    private TextView txtRight;
    private TextView txtWrong;
    private TextView txt;
    private TextView txtCurScale;
    private TextView txtHighScore;
    
    protected ToggleButton btnA;
	protected ToggleButton btnB;
	protected ToggleButton btnC;
	protected ToggleButton btnD;
	protected ToggleButton btnE;
	protected ToggleButton btnF;
	protected ToggleButton btnG;
	protected Button btnNext;
    
	private ToggleButton[] btnArrayKeys;
    private Game game;
    private AlertDialog.Builder alt_bld;
    private int nHighScore;
    
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setUpEndGameAlert();
        setUpSplashScreen();
    }
    
    private void setUpSplashScreen()
    {
    	setContentView(R.layout.splashscreen);
        btnNewGame = (Button) findViewById(R.id.btn_newGame);
        btnNewGame.setOnClickListener(oclExitSplash);
        txtHighScore = (TextView) findViewById(R.id.txt_highScore);
        // Restore high score
        SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
        nHighScore = settings.getInt("highscore", 0);
        
        System.out.println("high score: " + nHighScore);
        String sHighScore = "High score: " + Integer.toString(nHighScore);
        txtHighScore.setText(sHighScore);
    }
    
    private void startNewGame()
    {
    	checkSetHighScore();
    	game.resetGame();
    	game.randomScale();
    	updateGUI();
    	setUpGameDisplay();
    	setUpGameButtons();
    }
    
    private void checkSetHighScore()
    {
    	// update high score if needed
    	if(game.getRight() > nHighScore)
    	{
    		SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
            settings.edit().putInt("highscore", game.getRight()).commit();
    	}
    }
    
    private OnClickListener oclExitSplash = new OnClickListener() {
        public void onClick(View v) {
        	/*
        	 * Main game has begun
        	*/
        	setContentView(R.layout.main);
	        
        	game = new Game();
        	game.randomScale();
        	setUpGameDisplay();
        	setUpGameButtons();
        }
    };
    
    private void setUpGameDisplay()
    {
    	txt = (TextView) findViewById(R.id.txt_scaleInfo);
        txtCurScale = (TextView) findViewById(R.id.txt_currentScale);
        txtTimer = (TextView) findViewById(R.id.txt_timeLeft);
        txtRight = (TextView) findViewById(R.id.txt_numRight);
        txtWrong = (TextView) findViewById(R.id.txt_numWrong);
        txtHighScore = (TextView) findViewById(R.id.txt_highScore);
        btnNext = (Button) findViewById(R.id.btn_next);
        
        // initial scale for player
        txtCurScale.setText(game.randomScale().getRootNoteString());
        
        // make the counter
        new CountDownTimer(60000, 1000) {

            public void onTick(long millisUntilFinished) {
                txtTimer.setText(Long.toString(millisUntilFinished / 1000));
            }

            public void onFinish() {
            	
            	//alt_bld.setTitle(Integer.toString(game.getRight()));
            	AlertDialog alert = alt_bld.create();
            	alert.setTitle("Total Correct: " + game.getRight());
            	alert.setIcon(R.drawable.icon);
            	alert.show();
            }
         }.start();
    }
    
    private void setUpGameButtons()
	{
		// associate the btns with the GUI in XML
		btnA = (ToggleButton) findViewById(R.id.btn_a);
    	btnB = (ToggleButton) findViewById(R.id.btn_b);
    	btnC = (ToggleButton) findViewById(R.id.btn_c);
    	btnD = (ToggleButton) findViewById(R.id.btn_d);
    	btnE = (ToggleButton) findViewById(R.id.btn_e);
    	btnF = (ToggleButton) findViewById(R.id.btn_f);
    	btnG = (ToggleButton) findViewById(R.id.btn_g);
    	btnNext = (Button) findViewById(R.id.btn_next);
    	
    	btnArrayKeys = new ToggleButton[7];
    	btnArrayKeys[0] = btnA;
    	btnArrayKeys[1] = btnB;
    	btnArrayKeys[2] = btnC;
    	btnArrayKeys[3] = btnD;
    	btnArrayKeys[4] = btnE;
    	btnArrayKeys[5] = btnF;
    	btnArrayKeys[6] = btnG;
    	for(int i=0; i<btnArrayKeys.length;i++)
			{btnArrayKeys[i].setChecked(false);}
    	
    	// button for cycling through scales (alpha code)
    	//btn = (Button) findViewById(R.id.btn_clickme);
    	
    	setUpButtonListeners();
	}
    
    private void setUpButtonListeners()
    {
    	// check player toggleButton inputs and show new scale
    	btnNext.setOnClickListener(new View.OnClickListener()
    	{
    		public void onClick(View v) {
				// check player's choices
    			int[] aPlayerSelections = getPlayerKeysAsArray();
    			int[] aScaleNotes = game.getCurScale().getNoteArray();
    			Arrays.sort(aScaleNotes);
    			//System.out.println("aScaleNotes" + Arrays.toString(aScaleNotes));
    			//System.out.println("aPlayerSelections" + Arrays.toString(aPlayerSelections));
    			
    			// update right/wrong board
    			if(Arrays.equals(aPlayerSelections, aScaleNotes))
    				// player got it correct
    				game.incrRight();
    			else
    				// player is wrong
    				game.incrWrong();
    			
    			// reset key buttons and show new scale
    			for(int i=0; i<btnArrayKeys.length;i++)
    				{btnArrayKeys[i].setChecked(false);}
    			game.randomScale();
    			updateGUI();
				}
    	});
    	/*
    	btn.setOnClickListener(new View.OnClickListener()
        {
			public void onClick(View v) {
				Scale newScale = game.randomScale();
				txt.setText(newScale.toString());
				txtCurScale.setText(newScale.getRootNoteString());
				}
		});
		*/
    }
    
    private void updateGUI()
    {
    	txtRight.setText(Integer.toString(game.getRight()));
    	txtWrong.setText(Integer.toString(game.getWrong()));
    	txtCurScale.setText(game.getCurScale().getRootNoteString());
    	
    	txt.setText(game.getPreScale().toString());
    }
    
    private int[] getPlayerKeysAsArray()
	{
    	int[] aTemp = new int[7];// player's selected notes
    	
    	//if key is not checked, add to array
    	if(!btnA.isChecked())
    		aTemp[0] = NOTE_A;
    	else
    	{
    		switch(game.getCurScale().getSharpFlatNatural())
        	{
        	case SCALE_NATURAL:
        		aTemp[0] = NOTE_A;
        		break;
        	case SCALE_FLAT:
        		aTemp[0] = NOTE_AB;
        		break;
        	case SCALE_SHARP:
        		aTemp[0] = NOTE_AS;
        		break;
        	}
    	}
    	if(!btnB.isChecked())
    		aTemp[1] = NOTE_B;
    	else
    	{
    		switch(game.getCurScale().getSharpFlatNatural())
        	{
        	case SCALE_NATURAL:
        		aTemp[1] = NOTE_B;
        		break;
        	case SCALE_FLAT:
        		aTemp[1] = NOTE_BB;
        		break;
        	case SCALE_SHARP:
        		aTemp[1] = NOTE_BS;
        		break;
        	}
    	}
    	if(!btnC.isChecked())
    		aTemp[2] = NOTE_C;
    	else
    	{
    		switch(game.getCurScale().getSharpFlatNatural())
        	{
        	case SCALE_NATURAL:
        		aTemp[2] = NOTE_C;
        		break;
        	case SCALE_FLAT:
        		aTemp[2] = NOTE_CB;
        		break;
        	case SCALE_SHARP:
        		aTemp[2] = NOTE_CS;
        		break;
        	}
    	}
    	if(!btnD.isChecked())
    		aTemp[3] = NOTE_D;
    	else
    	{
    		switch(game.getCurScale().getSharpFlatNatural())
        	{
        	case SCALE_NATURAL:
        		aTemp[3] = NOTE_D;
        		break;
        	case SCALE_FLAT:
        		aTemp[3] = NOTE_DB;
        		break;
        	case SCALE_SHARP:
        		aTemp[3] = NOTE_DS;
        		break;
        	}
    	}
    	if(!btnE.isChecked())
    		aTemp[4] = NOTE_E;
    	else
    	{
    		switch(game.getCurScale().getSharpFlatNatural())
        	{
        	case SCALE_NATURAL:
        		aTemp[4] = NOTE_E;
        		break;
        	case SCALE_FLAT:
        		aTemp[4] = NOTE_EB;
        		break;
        	case SCALE_SHARP:
        		aTemp[4] = NOTE_ES;
        		break;
        	}
    	}
    	if(!btnF.isChecked())
    		aTemp[5] = NOTE_F;
    	else
    	{
    		switch(game.getCurScale().getSharpFlatNatural())
        	{
        	case SCALE_NATURAL:
        		aTemp[5] = NOTE_F;
        		break;
        	case SCALE_FLAT:
        		aTemp[5] = NOTE_FB;
        		break;
        	case SCALE_SHARP:
        		aTemp[5] = NOTE_FS;
        		break;
        	}
    	}
    	if(!btnG.isChecked())
    		aTemp[6] = NOTE_G;
    	else
    	{
    		switch(game.getCurScale().getSharpFlatNatural())
        	{
        	case SCALE_NATURAL:
        		aTemp[6] = NOTE_G;
        		break;
        	case SCALE_FLAT:
        		aTemp[6] = NOTE_GB;
        		break;
        	case SCALE_SHARP:
        		aTemp[6] = NOTE_GS;
        		break;
        	}
    	}
    	
    	Arrays.sort(aTemp);
    	return aTemp;
	}

    private void setUpEndGameAlert()
    {
    	alt_bld = new AlertDialog.Builder(this);
    	alt_bld.setCancelable(false)
    	.setPositiveButton("New Game", new DialogInterface.OnClickListener() {
			
			public void onClick(DialogInterface dialog, int which) {
				startNewGame();
			}
		})
		.setNegativeButton("Exit", new DialogInterface.OnClickListener() {
			
			public void onClick(DialogInterface dialog, int which) {
				checkSetHighScore();
				setUpSplashScreen();
			}
		});
    }
}