package jeremiahteague.com;


public class Scale implements Constants{
	
	private int[] notes;
	private int root;
	private int sharp_flat;
	
	public Scale(int scaleKey)
	{
		this.notes =  new int[7];
		this.root = scaleKey;
		this.sharp_flat = SCALE_NATURAL;
		
		/*
		 * Major Scales
		 */
		if(scaleKey == SCALE_AB)
		{
			notes[0] = NOTE_AB;
			notes[1] = NOTE_BB;
			notes[2] = NOTE_C;
			notes[3] = NOTE_DB;
			notes[4] = NOTE_EB;
			notes[5] = NOTE_F;
			notes[6] = NOTE_G;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_A)
		{
			notes[0] = NOTE_A;
			notes[1] = NOTE_B;
			notes[2] = NOTE_CS;
			notes[3] = NOTE_D;
			notes[4] = NOTE_E;
			notes[5] = NOTE_FS;
			notes[6] = NOTE_GS;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_BB)
		{
			notes[0] = NOTE_BB;
			notes[1] = NOTE_C;
			notes[2] = NOTE_D;
			notes[3] = NOTE_EB;
			notes[4] = NOTE_F;
			notes[5] = NOTE_G;
			notes[6] = NOTE_A;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_B)
		{
			notes[0] = NOTE_B;
			notes[1] = NOTE_CS;
			notes[2] = NOTE_DS;
			notes[3] = NOTE_E;
			notes[4] = NOTE_FS;
			notes[5] = NOTE_GS;
			notes[6] = NOTE_AS;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_CB)
		{
			notes[0] = NOTE_CB;
			notes[1] = NOTE_DB;
			notes[2] = NOTE_EB;
			notes[3] = NOTE_FB;
			notes[4] = NOTE_GB;
			notes[5] = NOTE_AB;
			notes[6] = NOTE_BB;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_C)
		{
			notes[0] = NOTE_C;
			notes[1] = NOTE_D;
			notes[2] = NOTE_E;
			notes[3] = NOTE_F;
			notes[4] = NOTE_G;
			notes[5] = NOTE_A;
			notes[6] = NOTE_B;
		}
		else if(scaleKey == SCALE_CS)
		{
			notes[0] = NOTE_CS;
			notes[1] = NOTE_DS;
			notes[2] = NOTE_ES;
			notes[3] = NOTE_FS;
			notes[4] = NOTE_GS;
			notes[5] = NOTE_AS;
			notes[6] = NOTE_BS;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_DB)
		{
			notes[0] = NOTE_DB;
			notes[1] = NOTE_EB;
			notes[2] = NOTE_F;
			notes[3] = NOTE_GB;
			notes[4] = NOTE_AB;
			notes[5] = NOTE_BB;
			notes[6] = NOTE_C;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_D)
		{
			notes[0] = NOTE_D;
			notes[1] = NOTE_E;
			notes[2] = NOTE_FS;
			notes[3] = NOTE_G;
			notes[4] = NOTE_A;
			notes[5] = NOTE_B;
			notes[6] = NOTE_CS;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_EB)
		{
			notes[0] = NOTE_EB;
			notes[1] = NOTE_F;
			notes[2] = NOTE_G;
			notes[3] = NOTE_AB;
			notes[4] = NOTE_BB;
			notes[5] = NOTE_C;
			notes[6] = NOTE_D;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_E)
		{
			notes[0] = NOTE_E;
			notes[1] = NOTE_FS;
			notes[2] = NOTE_GS;
			notes[3] = NOTE_A;
			notes[4] = NOTE_B;
			notes[5] = NOTE_CS;
			notes[6] = NOTE_DS;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_F)
		{
			notes[0] = NOTE_F;
			notes[1] = NOTE_G;
			notes[2] = NOTE_A;
			notes[3] = NOTE_BB;
			notes[4] = NOTE_C;
			notes[5] = NOTE_D;
			notes[6] = NOTE_E;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_FS)
		{
			notes[0] = NOTE_FS;
			notes[1] = NOTE_GS;
			notes[2] = NOTE_AS;
			notes[3] = NOTE_B;
			notes[4] = NOTE_CS;
			notes[5] = NOTE_DS;
			notes[6] = NOTE_ES;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_GB)
		{
			notes[0] = NOTE_GB;
			notes[1] = NOTE_AB;
			notes[2] = NOTE_BB;
			notes[3] = NOTE_CB;
			notes[4] = NOTE_DB;
			notes[5] = NOTE_EB;
			notes[6] = NOTE_F;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_G)
		{
			notes[0] = NOTE_G;
			notes[1] = NOTE_A;
			notes[2] = NOTE_B;
			notes[3] = NOTE_C;
			notes[4] = NOTE_D;
			notes[5] = NOTE_E;
			notes[6] = NOTE_FS;
			this.sharp_flat = SCALE_SHARP;
		}
		
		/*
		 * Minor Scales
		 */
		else if(scaleKey == SCALE_ABM)
		{
			notes[0] = NOTE_AB;
			notes[1] = NOTE_BB;
			notes[2] = NOTE_CB;
			notes[3] = NOTE_DB;
			notes[4] = NOTE_EB;
			notes[5] = NOTE_FB;
			notes[6] = NOTE_GB;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_AM)
		{
			notes[0] = NOTE_A;
			notes[1] = NOTE_B;
			notes[2] = NOTE_C;
			notes[3] = NOTE_D;
			notes[4] = NOTE_E;
			notes[5] = NOTE_F;
			notes[6] = NOTE_G;
		}
		else if(scaleKey == SCALE_ASM)
		{
			notes[0] = NOTE_AS;
			notes[1] = NOTE_BS;
			notes[2] = NOTE_CS;
			notes[3] = NOTE_DS;
			notes[4] = NOTE_ES;
			notes[5] = NOTE_FS;
			notes[6] = NOTE_GS;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_BBM)
		{
			notes[0] = NOTE_BB;
			notes[1] = NOTE_C;
			notes[2] = NOTE_DB;
			notes[3] = NOTE_EB;
			notes[4] = NOTE_F;
			notes[5] = NOTE_GB;
			notes[6] = NOTE_AB;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_BM)
		{
			notes[0] = NOTE_B;
			notes[1] = NOTE_CS;
			notes[2] = NOTE_D;
			notes[3] = NOTE_E;
			notes[4] = NOTE_FS;
			notes[5] = NOTE_G;
			notes[6] = NOTE_A;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_CM)
		{
			notes[0] = NOTE_C;
			notes[1] = NOTE_D;
			notes[2] = NOTE_EB;
			notes[3] = NOTE_F;
			notes[4] = NOTE_G;
			notes[5] = NOTE_AB;
			notes[6] = NOTE_BB;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_CSM)
		{
			notes[0] = NOTE_CS;
			notes[1] = NOTE_DS;
			notes[2] = NOTE_E;
			notes[3] = NOTE_FS;
			notes[4] = NOTE_GS;
			notes[5] = NOTE_A;
			notes[6] = NOTE_B;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_DM)
		{
			notes[0] = NOTE_D;
			notes[1] = NOTE_E;
			notes[2] = NOTE_F;
			notes[3] = NOTE_G;
			notes[4] = NOTE_A;
			notes[5] = NOTE_BB;
			notes[6] = NOTE_C;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_DSM)
		{
			notes[0] = NOTE_DS;
			notes[1] = NOTE_ES;
			notes[2] = NOTE_FS;
			notes[3] = NOTE_GS;
			notes[4] = NOTE_AS;
			notes[5] = NOTE_B;
			notes[6] = NOTE_CS;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_EBM)
		{
			notes[0] = NOTE_EB;
			notes[1] = NOTE_F;
			notes[2] = NOTE_GB;
			notes[3] = NOTE_AB;
			notes[4] = NOTE_BB;
			notes[5] = NOTE_CB;
			notes[6] = NOTE_DB;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_EM)
		{
			notes[0] = NOTE_E;
			notes[1] = NOTE_FS;
			notes[2] = NOTE_G;
			notes[3] = NOTE_A;
			notes[4] = NOTE_B;
			notes[5] = NOTE_C;
			notes[6] = NOTE_D;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_FM)
		{
			notes[0] = NOTE_F;
			notes[1] = NOTE_G;
			notes[2] = NOTE_AB;
			notes[3] = NOTE_BB;
			notes[4] = NOTE_C;
			notes[5] = NOTE_DB;
			notes[6] = NOTE_EB;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_FSM)
		{
			notes[0] = NOTE_FS;
			notes[1] = NOTE_GS;
			notes[2] = NOTE_A;
			notes[3] = NOTE_B;
			notes[4] = NOTE_CS;
			notes[5] = NOTE_D;
			notes[6] = NOTE_E;
			this.sharp_flat = SCALE_SHARP;
		}
		else if(scaleKey == SCALE_GM)
		{
			notes[0] = NOTE_G;
			notes[1] = NOTE_A;
			notes[2] = NOTE_BB;
			notes[3] = NOTE_C;
			notes[4] = NOTE_D;
			notes[5] = NOTE_EB;
			notes[6] = NOTE_F;
			this.sharp_flat = SCALE_FLAT;
		}
		else if(scaleKey == SCALE_GSM)
		{
			notes[0] = NOTE_GS;
			notes[1] = NOTE_AS;
			notes[2] = NOTE_B;
			notes[3] = NOTE_CS;
			notes[4] = NOTE_DS;
			notes[5] = NOTE_E;
			notes[6] = NOTE_FS;
			this.sharp_flat = SCALE_SHARP;
		}
	}
	
	public String toString()
	{
		return "Scale: " + getRootNoteString() + " contains: " + getNotesString();
	}
	
	public String getNotesString()
	{
		String strNotes = "";
		for(int i=0; i<7; i++)
		{
			switch(this.notes[i])
			{
				case NOTE_AB:
					strNotes += " Ab ";
					break;
				case NOTE_A:
					strNotes += " A ";
					break;
				case NOTE_AS:
					strNotes += " A# ";
					break;
				case NOTE_BB:
					strNotes += " Bb ";
					break;
				case NOTE_B:
					strNotes += " B ";
					break;
				case NOTE_BS:
					strNotes += " B# ";
					break;
				case NOTE_CB:
					strNotes += " Cb ";
					break;
				case NOTE_C:
					strNotes += " C ";
					break;
				case NOTE_CS:
					strNotes += " C# ";
					break;
				case NOTE_DB:
					strNotes += " Db ";
					break;
				case NOTE_D:
					strNotes += " D ";
					break;
				case NOTE_DS:
					strNotes += " D# ";
					break;
				case NOTE_EB:
					strNotes += " Eb ";
					break;
				case NOTE_E:
					strNotes += " E ";
					break;
				case NOTE_ES:
					strNotes += " E# ";
					break;
				case NOTE_FB:
					strNotes += " Fb ";
					break;
				case NOTE_F:
					strNotes += " F ";
					break;
				case NOTE_FS:
					strNotes += " F# ";
					break;
				case NOTE_GB:
					strNotes += " Gb ";
					break;
				case NOTE_G:
					strNotes += " G ";
					break;
				case NOTE_GS:
					strNotes += " G# ";
					break;
			}
		}
		return strNotes;
	}
	
	public String getRootNoteString()
	{
		String strRoot = "";
		switch(this.root)
		{
		case SCALE_AB:
			strRoot = "Ab Major";
			break;
		case SCALE_A:
			strRoot = "A Major";
			break;
		case SCALE_BB:
			strRoot = "Bb Major";
			break;
		case SCALE_B:
			strRoot = "B Major";
			break;
		case SCALE_CB:
			strRoot = "Cb Major";
			break;
		case SCALE_C:
			strRoot = "C Major";
			break;
		case SCALE_CS:
			strRoot = "C# Major";
			break;
		case SCALE_DB:
			strRoot = "Db Major";
			break;
		case SCALE_D:
			strRoot = "D Major";
			break;
		case SCALE_EB:
			strRoot = "Eb Major";
			break;
		case SCALE_E:
			strRoot = "E Major";
			break;
		case SCALE_F:
			strRoot = "F Major";
			break;
		case SCALE_FS:
			strRoot = "F# Major";
			break;
		case SCALE_GB:
			strRoot = "Gb Major";
			break;
		case SCALE_G:
			strRoot = "G Major";
			break;
		case SCALE_ABM:
			strRoot = "Ab Minor";
			break;
		case SCALE_AM:
			strRoot = "A Minor";
			break;
		case SCALE_ASM:
			strRoot = "A# Minor";
			break;
		case SCALE_BBM:
			strRoot = "Bb Minor";
			break;
		case SCALE_BM:
			strRoot = "B Minor";
			break;
		case SCALE_CM:
			strRoot = "C Minor";
			break;
		case SCALE_CSM:
			strRoot = "C# Minor";
			break;
		case SCALE_DM:
			strRoot = "D Minor";
			break;
		case SCALE_DSM:
			strRoot = "D# Minor";
			break;
		case SCALE_EBM:
			strRoot = "Eb Minor";
			break;
		case SCALE_EM:
			strRoot = "E Minor";
			break;
		case SCALE_FM:
			strRoot = "F Minor";
			break;
		case SCALE_FSM:
			strRoot = "F# Minor";
			break;
		case SCALE_GM:
			strRoot = "G Minor";
			break;
		case SCALE_GSM:
			strRoot = "G# minor";
			break;
		}
		return strRoot;
	}
	
	public int getSharpFlatNatural()	{return sharp_flat;}
	public int[] getNoteArray()			{return notes;}
	public int getRoot()				{return root;}
}
